<template>
  <div style="width:100%;height:100%">
      <div v-if="showTip" ref="showTip">
          <img ref="gravity_up" class="gravity_up" src="../../assets/images/up.png" alt="">
            <img ref="gravity_down" class="gravity_down" src="../../assets/images/down.png" alt="">
            <img ref="gravity_left" class="gravity_left" src="../../assets/images/left.png" alt="">
            <img ref="gravity_right" class="gravity_right" src="../../assets/images/right.png" alt="">
            <img ref="gravity_text" class="gravity_text" src="../../assets/images/gravity/text.png" alt="">
      </div>
    <div class="gravity_bg gravity_bg2" ref="gravity_bg">
      <span ref="span"></span>
      
      <div class="L_box">
        <img ref="L_line" class="L_line" src="../../assets/images/gravity/L/l-line.png" alt="">
        <img ref="L_star1" class="L_star1" src="../../assets/images/gravity/L/l-star1.png" alt="">
        <img ref="L_star2" class="L_star2" src="../../assets/images/gravity/L/l-star2.png" alt="">
        <img ref="L_text" class="L_text" src="../../assets/images/gravity/L/l-text.png" alt="">
        <img @click="goStart()" ref="L_btn" class="L_btn" src="../../assets/images/gravity/btn.png" alt="">
      </div>
      <div class="I_box">
        <img class="I_line" ref="I_line" src="../../assets/images/gravity/I/i-line.png" alt="">
        <img ref="I_star1" class="I_star1" src="../../assets/images/gravity/I/i-star1.png" alt="">
        <img ref="I_star2" class="I_star2" src="../../assets/images/gravity/I/i-star2.png" alt="">
        <img class="I_text" ref="I_text" src="../../assets/images/gravity/I/i-text.png" alt="">
        <img @click="goStart()" ref="I_btn" class="I_btn" src="../../assets/images/gravity/btn.png" alt="">
      </div>
      <div class="P_box">
        <img ref="P_line" class="P_line" src="../../assets/images/gravity/P/p-line.png" alt="">
        <img ref="P_star1" class="P_star1" src="../../assets/images/gravity/P/p-star1.png" alt="">
        <img ref="P_star2" class="P_star2" src="../../assets/images/gravity/P/p-star2.png" alt="">
        <img ref="P_text" class="P_text" src="../../assets/images/gravity/P/p-text.png" alt="">
        <img @click="goStart()" ref="P_btn" class="P_btn" src="../../assets/images/gravity/btn.png" alt="">
      </div>
      <div class="S_box">
        <img ref='S_line' class="S_line" src="../../assets/images/gravity/S/s-line.png" alt="">
        <img ref="S_star1" class="S_star1" src="../../assets/images/gravity/S/s-star1.png" alt="">
        <img ref="S_star2" class="S_star2" src="../../assets/images/gravity/S/s-star2.png" alt="">
        <img ref="S_text" class="S_text" src="../../assets/images/gravity/S/s-text.png" alt="">
        <img @click="goStart()" ref="S_btn" class="S_btn" src="../../assets/images/gravity/btn.png" alt="">
      </div>
      <div class="A_box">
        <img ref="A_line" class="A_line" src="../../assets/images/gravity/A/a-line.png" alt="">
        <img ref="A_star1" class="A_star1" src="../../assets/images/gravity/A/a-star1.png" alt="">
        <img ref="A_star2" class="A_star2" src="../../assets/images/gravity/A/a-star2.png" alt="">
        <img ref="A_text" class="A_text" src="../../assets/images/gravity/A/a-text.png" alt="">
        <img @click="goStart()" ref="A_btn" class="A_btn" src="../../assets/images/gravity/btn.png" alt="">
      </div>
      <div class="C_box">
        <img ref="C_line" class="C_line" src="../../assets/images/gravity/C/c-line.png" alt="">
        <img ref="C_star1" class="C_star1" src="../../assets/images/gravity/C/c-star1.png" alt="">
        <img ref="C_star2" class="C_star2" src="../../assets/images/gravity/C/c-star2.png" alt="">
        <img ref="C_text" class="C_text" src="../../assets/images/gravity/C/c-text.png" alt="">
        <img @click="goStart()" ref="C_btn" class="C_btn" src="../../assets/images/gravity/btn.png" alt="">
      </div>

      <img ref="starImg" @load="load3" class="starImg starImg2" src="../../assets/images/gravity/bg-none2.jpg" alt="">
    </div>
    <!-- <div ref="showInfo" class="showInfo" style="position: fixed;top:0;right:0;color:white;">显示信息</div>
    <div ref="showInfo2" class="showInfo2" style="position: fixed;top:0;left:0;color:white;">显示信息</div> -->

  </div>

</template>

<script>
    let currentX = 0,
        currentY = 0,
        currentZ = 0,
        lastX = 0,
        lastY = 0,
        lastZ = 0,
        leftPX = 0,
        topPX = 0;
    let basePX = 5 //移动速度
    let mo = function(e) {
        e.preventDefault();
    };
    // var vConsole = new VConsole();
    export default {
        name: 'Gravity',
        data() {
            return {
                current: 'Gravity',
                devicemotion_start: false,
                devicemotion_obj: {},
                devicemotion_moveImgObj: {},
                showTip:true
            }
        },
        methods: {
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            goStart() {
                // document.body.style.overflow = 'scroll'
                document.removeEventListener("touchmove", mo, { passive: false });
                // window.removeEventListener(
                //   "devicemotion",
                //   this.deviceMotionHandler,
                //   false
                // );
                if (this.orienterr) {
                    this.orienterr.off();
                }
                this.current = "none";
                this.$router.replace("/starpoint/start");
            },
            load3() {
                var documentW = document.documentElement.clientWidth;
                var documentH = document.documentElement.clientHeight;
                // var _width = parseInt(getComputedStyle(this.$refs.gravity_bg).width);
                // var _height = parseInt(getComputedStyle(this.$refs.gravity_bg).height);
                //gravity_bg
                var _width = 1800;
                var _height = 1200;


                var moveImgObj = {
                    transX: -_width / 2,
                    transY: -_height / 2,
                    newX: '',
                    newY: '',
                    maxX: _width / 2 - documentW / 2,
                    maxY: _height / 2 - documentH / 2,
                    lon: '', //保存载入时lon，不同位置刷新后初始值一致
                    lat: '', //保存载入时lat，不同位置刷新后初始值一致
                    // stepX: 4.88 * 3, //440/90 1200/90
                    // stepY: 4.44 * 2, //200/45 600/45    13.333333333333334
                    stepX: 13.3 * 2, //440/90 1200/90
                    stepY: 13.3 * 2, //200/45 600/45
                }

                var o = new Orienter();
                o.onOrient = (obj) => {
                    // this.$refs.showInfo.innerHTML =
                    //     'alpha:' + obj.a +
                    //     '<br>' + 'beta:' + obj.b +
                    //     '<br>' + 'gamma:' + obj.g +
                    //     '<br>' + 'longitude:' + obj.lon +
                    //     '<br>' + 'latitude:' + obj.lat +
                    //     '<br>' + 'direction:' + obj.dir +
                    //     '<br>' + 'newX:' + moveImgObj.newX +
                    //     '<br>' + 'newY:' + moveImgObj.newY;

                    // this.startMove(obj, moveImgObj);

                    this.devicemotion_obj = obj;
                    this.devicemotion_moveImgObj = moveImgObj;
                    if (!this.devicemotion_start) {
                        this.devicemotion_start = true;
                        this.startMove(obj, moveImgObj);
                    }
                };
                o.on();
            },
            startMove(obj, moveImgObj) {
                var requestAnimationFrame =
                    window.requestAnimationFrame || //Chromium  
                    window.webkitRequestAnimationFrame || //Webkit 
                    window.mozRequestAnimationFrame || //Mozilla Geko 
                    window.oRequestAnimationFrame || //Opera Presto 
                    window.msRequestAnimationFrame || //IE Trident? 
                    function(callback) { //Fallback function 
                        window.setTimeout(callback, 1000 / 60);
                    };

                var e, pe, pid, fps, last, offset, step, appendFps;
                var showFPS, moveCalculation;

                fps = 0;
                last = Date.now();
                showFPS = () => {
                    offset = Date.now() - last;
                    fps += 1;
                    if (offset >= 1000) {
                        last += offset;
                        // this.$refs.showInfo.innerHTML = fps
                        fps = 0;
                    }
                }
                moveCalculation = () => {
                    showFPS();

                    obj = this.devicemotion_obj;
                    moveImgObj = this.devicemotion_moveImgObj;

                    // console.log(moveImgObj)
                    if (moveImgObj.lon == "") {
                        if (obj.lon > 180) {
                            moveImgObj.lon = obj.lon = 0;
                        } else {
                            moveImgObj.lon = obj.lon
                        }
                    }
                    if (moveImgObj.lat == "") {
                        moveImgObj.lat = obj.lat
                    }

                    var a, b;
                    //lon,lat 当成平移距离来计算
                    a = obj.lon < 180 ? obj.lon : obj.lon - 360;
                    b = obj.lat;

                    // console.log([a, b], [obj.lon, obj.lat]);

                    a = (a - moveImgObj.lon) * moveImgObj.stepX;
                    b = (b - moveImgObj.lat) * moveImgObj.stepY;

                    a = a > 0 ? (a > moveImgObj.maxX ? moveImgObj.maxX : a) : (a < -moveImgObj.maxX ? -moveImgObj.maxX : a);
                    b = b > 0 ? (b > moveImgObj.maxY ? moveImgObj.maxY : b) : (b < -moveImgObj.maxY ? -moveImgObj.maxY : b);


                    moveImgObj.newX = moveImgObj.transX + a;
                    moveImgObj.newY = moveImgObj.transY + b;
                    this.$refs.gravity_bg.style.webkitTransform = "translate3d(" + moveImgObj.newX + "px," + moveImgObj
                        .newY + "px,0)";

                    this.showLayer(moveImgObj, a, b);
                    // this.startMove(obj, moveImgObj);
                    requestAnimationFrame(moveCalculation);
                }
                moveCalculation()

            },
            showLayer(moveImgObj, leftPX, topPX) {
                // var _dx = moveImgObj.transX + moveImgObj.maxX;
                // var _dy = moveImgObj.transY + moveImgObj.maxY;
                leftPX = (leftPX - moveImgObj.maxX) * -1;
                topPX = (topPX - moveImgObj.maxY) * -1;

                // this.$refs.showInfo2.innerHTML =
                //     'leftPX:' + leftPX +
                //     '<br>' + 'topPX:' + topPX;
                // console.log(leftPX, topPX)
                if ((leftPX >= 20 && leftPX <= 180) && topPX <= 200) {
                    // l星位置
                    this.$refs.L_star1.classList.add("fadeIn");
                    this.$refs.L_star2.classList.add("fadeIn_1");
                    this.$refs.L_line.classList.add("fadeIn_2");
                    this.$refs.L_text.classList.add("fadeIn_3");
                    this.$refs.L_btn.classList.add("fadeIn_4");
                } else if ((leftPX >= 500 && leftPX <= 650) && topPX <= 100) {
                    //i星位置
                    this.$refs.I_star1.classList.add("fadeIn");
                    this.$refs.I_star2.classList.add("fadeIn_1");
                    this.$refs.I_line.classList.add("fadeIn_2");
                    this.$refs.I_text.classList.add("fadeIn_3");
                    this.$refs.I_btn.classList.add("fadeIn_4");
                } else if ((leftPX > 1000 && leftPX <= 1200) && topPX <= 150) {
                    //p星位置
                    this.$refs.P_star1.classList.add("fadeIn");
                    this.$refs.P_star2.classList.add("fadeIn_1");
                    this.$refs.P_line.classList.add("fadeIn_2");
                    this.$refs.P_text.classList.add("fadeIn_3");
                    this.$refs.P_btn.classList.add("fadeIn_4");
                } else if ((leftPX >= 300 && leftPX <= 400) && topPX > 300) {
                    //S星位置
                    this.$refs.S_star1.classList.add("fadeIn");
                    this.$refs.S_star2.classList.add("fadeIn_1");
                    this.$refs.S_line.classList.add("fadeIn_2");
                    this.$refs.S_text.classList.add("fadeIn_3");
                    this.$refs.S_btn.classList.add("fadeIn_4");
                } else if ((leftPX >= 800 && leftPX <= 900) && topPX > 300) {
                    //A星位置
                    this.$refs.A_star1.classList.add("fadeIn");
                    this.$refs.A_star2.classList.add("fadeIn_1");
                    this.$refs.A_line.classList.add("fadeIn_2");
                    this.$refs.A_text.classList.add("fadeIn_3");
                    this.$refs.A_btn.classList.add("fadeIn_4");
                } else if (leftPX >= 1300 && topPX > 300) {
                    //C星位置
                    this.$refs.C_star1.classList.add("fadeIn");
                    this.$refs.C_star2.classList.add("fadeIn_1");
                    this.$refs.C_line.classList.add("fadeIn_2");
                    this.$refs.C_text.classList.add("fadeIn_3");
                    this.$refs.C_btn.classList.add("fadeIn_4");
                }
            },
        },
        mounted() {
            let that = this
            this.$refs.gravity_up.addEventListener('animationend', function() { 
                that.showTip = false;
            }, false)

            //禁止用户滑动页面
            // document.body.style.overflow='hidden';
            document.addEventListener("touchmove", mo, {
                passive: false
            }); //禁止页面滑动
            // this.$dialog.loading.open('图片正在加载中。。');

        }
    }
</script>

<style scoped lang='less'>

   @-webkit-keyframes fadeOut {
        0% {
            opacity: 1;
        }
        100% {
            opacity: 0;
        }
    }
    
    @keyframes fadeOut {
        0% {
            opacity: 1;
        }
        100% {
            opacity: 0;
        }
    }
        .gravity_up,.gravity_down,.gravity_left,.gravity_right,.gravity_text{
            position: fixed;
            z-index: 5;
            animation:fadeOut 1s ease-in forwards; 
            animation-delay: 1000ms;
        }
        .gravity_up{
            top: 10px;
            left: 50%;
            transform: translate(-50%);
            width: 50px;
            height: 30px;
        }
        .gravity_down{
            bottom: 10px;
            left: 50%;
            transform: translate(-50%);
            width: 50px;
            height: 30px;
        }
        .gravity_left{
            left: 10px;
            top: 50%;
            transform: translate(0,-50%);
            width: 30px;
            height: 50px;
        }
        .gravity_right{
            right: 10px;
            top: 50%;
            transform: translate(0,-50%);
            width: 30px;
            height: 50px;
        }

        .gravity_text{
            width: 35%;
            top: 50%;
            left: 50%;
            transform: translate(-50%,-50%);
        }
    .gravity_bg {
        // width: 2250px;
        width: 1800px;
        height: 1200px;
        overflow: scroll;
        span {
            position: fixed;
            top: 0;
            left: 0;
            color: #ffffff;
            z-index: 5
        }
        
        .L_box {
            transform: scale(0.7);
            position: absolute;
            top: 0;
            left: 120px;
            //  border: 2px  solid red;
            width: 362px;
            height: 559px;
            z-index: 2;
            display: flex;
            justify-content: center;
            align-items: center;
            img {
                position: absolute;
               opacity: 0;
            }
            .L_text {
                right: -10px;
            }
            .L_line {
                top: 50%;
                left: 50%;
                transform: translate(-50%, -50%);
            }
            .L_star1 {
                top: 30px;
                left: 25px;
            }
            .L_star2 {
                bottom: 30px;
            }
            .L_btn {
                bottom: 170px;
                width: 35%;
                left: 180px;
                z-index: 6;
            }
        }
        .I_box {
            transform: scale(0.7);
            position: absolute;
            top: 0px;
            left: 600px;
            width: 362px;
            height: 559px;
            z-index: 2;
            display: flex;
            justify-content: center;
            align-items: center;
            //  border: 2px  solid red;
            img {
                position: absolute;
               opacity: 0;
            }
            .I_line {
                top: 50%;
                left: 50%;
                transform: translate(-50%, -50%);
            }
            .I_star1 {
                top: 52px;
                right: -15px;
            }
            .I_star2 {
                bottom: 40px;
                right: 125px;
            }
            .I_text {
                left: 0;
                top: 0;
            }
            .I_btn {
                top: 380px;
                width: 35%;
                right: 10px;
                z-index: 6;
            }
        }
        .P_box {
            transform: scale(0.7);
            position: absolute;
            top: 0;
            left: 1100px;
            width: 362px;
            height: 559px;
            z-index: 2;
            display: flex;
            justify-content: center;
            // border: 2px  solid red;
            align-items: center;
            img {
                position: absolute;
               opacity: 0;
            }
            .P_line {
                top: 50%;
                left: 50%;
                transform: translate(-50%, -50%);
            }
            .P_star1 {
                top: 90px;
                left: 30px;
            }
            .P_star2 {
                right: 0;
                top: 50%;
                transform: translateY(-50%);
            }
            .P_text {
                bottom: -30px;
                left: 50%;
                transform: translateX(-50%);
            }
            .P_btn {
                top: 345px;
                width: 35%;
                right: 0;
                z-index: 6;
            }
        }
        .S_box {
            transform: scale(0.7);
            position: absolute;
            top: 650px;
            left: 360px;
            width: 362px;
            height: 559px;
            z-index: 2;
            //  border: 2px  solid red;
            display: flex;
            justify-content: center;
            align-items: center;
            img {
                position: absolute;
               opacity: 0;
            }
            .S_line {
                top: 50%;
                left: 50%;
                transform: translate(-50%, -50%);
            }
            .S_star1 {
                top: 80px;
                right: 20px;
            }
            .S_star2 {
                bottom: 90px;
                right: 10px;
            }
            .S_text {
                bottom: -30px;
                left: 0;
            }
            .S_btn {
                bottom: 20px;
                width: 35%;
                right: -30px;
                z-index: 6;
            }
        }
        .A_box {
            transform: scale(0.7);
            position: absolute;
            top: 650px;
            left: 860px;
            width: 362px;
            height: 559px;
            z-index: 2;
            display: flex;
            justify-content: center;
            align-items: center;
            // border: 2px  solid red;
            img {
                position: absolute;
               opacity: 0;
            }
            .A_line {
                top: 50%;
                left: 50%;
                transform: translate(-50%, -50%);
            }
            .A_star1 {
                top: 100px;
                left: 80px;
            }
            .A_star2 {
                bottom: 80px;
                right: 0;
            }
            .A_text {
                top: -10px;
                right: -45px;
            }
            .A_btn {
                bottom: 40px;
                width: 35%;
                left: 50%;
                transform: translateX(-50%);
                z-index: 6;
            }
        }
        .C_box {
            transform: scale(0.7);
            position: absolute;
            top: 650px;
            left: 1350px;
            width: 362px;
            height: 559px;
            z-index: 2;
            display: flex;
            justify-content: center;
            align-items: center;
            //  border: 2px  solid red;
            img {
                position: absolute;
               opacity: 0;
            }
            .C_star1 {
                transform: rotateZ(15deg);
                top: 94px;
                right: 35px;
            }
            .C_star2 {
                top: -53px;
                left: 40px;
                transform: rotateZ(15deg);
            }
            .C_text {
                right: 10px;
                top: 50%;
                transform: translateY(-50%);
            }
            .C_btn {
                width: 35%;
                bottom: 30px;
                left: 50%;
                transform: translateX(-50%);
                z-index: 6;
            }
            .C_line {
                top: 0;
                left: 50%;
                transform: translateX(-50%) rotateZ(15deg);
            }
        }
    }
    
    .starImg {
        position: absolute;
        width: 2250px;
        height: 1200px;
        top: 0;
        left: 0;
    }
    
    .gravity_bg2 {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate3d(-1125px, -600px, 0px);
        transition: all 0.8s linear;
    }
    
    .starImg2 {
        position: relative;
        width: 100%;
        height: auto;
        top: auto;
        left: auto;
    }
    
    img {
        // animation:fadeIn 2s ease-in; 
    }
    
    .fadeIn {
        animation: fadeIn 0.3s ease-in;
        animation-fill-mode: forwards;
    }
    
    .fadeIn_1 {
        animation: fadeIn 0.3s ease-in;
        animation-delay: 300ms;
        animation-fill-mode: forwards;
    }
    
    .fadeIn_2 {
        animation: fadeIn 0.3s ease-in;
        animation-delay: 600ms;
        animation-fill-mode: forwards;
    }
    
    .fadeIn_3 {
        animation: fadeIn 0.3s ease-in;
        animation-delay: 900ms;
        animation-fill-mode: forwards;
    }
    
    .fadeIn_4 {
        animation: fadeIn 0.3s ease-in;
        animation-delay: 1000ms;
        animation-fill-mode: forwards;
    }
</style>